
/* List view is already a component */

ListView = Vue.component('list-view', (
{
  data: function() {
    return { entrylist: this.$parent.entrylist } // BAD IDEA: see appdata below...
  },
  template: '<div class="two columns"><ul><list-item v-for="item in entrylist" :key="item.id" :idnum="item.id" :name="item.name"></list-item></ul></div>',
}
))


/* nice component */
Vue.component( 'list-item', (
  {
    props: [ 'idnum', 'name'],
    computed: {
      addr: function() {
        return "#/item/" + this.idnum;
      }
    },
    template: '<li><a :href="addr">{{name}}</a></li>'
  }
))

const Add = Vue.component('add-view', ({ 
  
  data: function() {
    return { entrylist: this.$parent.entrylist } // NOTE BAD IDEA HERE TOO: see below
  },
  methods: {
    addNew: function() {
      this.entrylist.push({id:3, name:"foo"})
    }
  },
  template: 
  `
  <div>
  <h2>Lisamine</h2>
  <form>
  <input type="text" id="name"/>
  <input type="submit" @click="addNew"/>
  </form>
  </div>
  `
}
))

/* APPLICATION STATE */

/* 
NOTE: bad idea to use it for sharing data directly. We should
be sharing parts of it to components as needed and we should
be changing it using events since it will be a debugging hell
for anything non-trivial.
*/

const appstate = 
    { 
      entrylist: [
        { id:1, name:"asd"},
        { id:0, name:"dsa"}
      ]
    }


/* ROUTER ELEMENTS */
routes = [
  { path: '/list', component: ListView },
  { path: '/add', component: Add },
  { path: '/item/:id', component: {template: '<div><h1>Details {{$route.params.id}}</h1><div></div></div>'} } // change into a proper component
]

const router = new VueRouter(
  {routes, linkActiveClass: "button-primary"}
)

/* VUE APP */

var vm = new Vue(
{ 
  router,
  data: appstate
}
).$mount('#dogapp');
